//  support function for MOS
//      1 Apr 2016,  no it is not April Fool
//      all MOS support here is deleted
//			13 Apr 2016  Happy Songkran
//      add semaphore		15 Apr 2016
//		mod for multicore   20 Apr 2016

#include "s30.h"

#define  PRIVATE   static

/*   data in S2 space

global variables

nump
currentp

process queue  size 16 words

process control block
struct { PC, SP, ... }   size 16 words

stack of each process size 64 words

memory map

0...900    code
1000       int vec
1500       global var

semptr    3000     allocate semaphore

*/

extern int M[], currentcore;

int semptr = 3000;

int newsem(void){
	int a;
	a = semptr;
	M[a] = 1;			// init value to 1
	M[a+1] = 0;			// clear Q
	semptr += 16;
	return a;
}

PRIVATE void blockp(int p){
	trap(p,23);				// wait for int
}

PRIVATE void wakeup(int p){
	trap(p,24);				// intx p
}

void wait(int sem){
	int v, end, core;
	M[sem]--;				// value--
	v = M[sem];
	if( v < 0 ){
		end = -v;			// enqueue currentcore
		M[sem+end] = currentcore;
		M[sem+end+1] = 0;
		blockp(currentcore);
	}
}

// dequeue semaphore queue
PRIVATE int desemq(int sem){
	int a, i;
	a = M[sem+1];			// get the first in queue
	i = sem+2;
	while(M[i] != 0){
		M[i-1] = M[i];		// move element left
		i++;
	}
	M[i-1] = 0;
	return a;
}

void signal(int sem){
	int p;
	if( M[sem] < 1 ) M[sem]++;
	if( M[sem] <= 0 ){
		p = desemq(sem);
		wakeup(p);
//		printf("wakeup %d\n",p);
	}
}


